"""
The mappings are based of https://www.thecrag.com/en/article/grades,
which contains all grades in a form of tables.
"""

VALID_NAMES = (
    ("Band Sport",),
    ("Ewbanks", "AU", "Australia", "New Zealand"),
    ("YDS", "Yosemitee", "American", "US"),
    ("NCCS Scale", "Commitment Grade"),
    ("French", "FR"),
    ("British Tech.", "UK", "British"),
    ("UIAA",),
    ("South African", "SA"),
    ("Old South African", "OSA"),
    ("Saxon", "SX"),
    ("Finnish", "FIN"),
    ("Norwegian", "NWG"),
    ("Polish", "PL", "Kurtyki"),
    ("Brazil Technical", "BRZ", "Brazilian"),
    ("Swedish", "SWE"),
    ("Russian", "RU"),
    ("Band Boulder",),
    ("V-Scale", "V"),
    ("B-Scale", "B"),
    ("S-Scale", "S"),
    ("P-Scale", "P"),
    ("Joshua Tree Scale", "Joshua"),
    ("Fontainebleau", "Font"),
    ("Annot B-Scale",),
    ("Font Traverse",),
    ("Band Other",),
    ("Aid",),
    ("Alpine Ice",),
    ("Water Ice",),
    ("Mixed Rock/Ice",),
    ("Ferrata Schall",),
    ("Ferrata Num",),
    ("Ferrata French",),
    ("Scottish Winter Technical",),
)

BOULDER_SYSTEMS = (
    "Band Boulder",
    "V-Scale",
    "B-Scale",
    "S-Scale",
    "P-Scale",
    "Joshua Tree Scale",
    "Fontainebleau",
    "Annot B-Scale",
    "Font Traverse",
)

OTHER_SYSTEMS = (
    "Band Other",
    "Aid",
    "Alpine Ice",
    "Water Ice",
    "Mixed Rock/Ice",
    "Ferrata Schall",
    "Ferrata Num",
    "Ferrata French",
    "Scottish Winter Technical",
)

NAMING_MAP = {}
for system in VALID_NAMES:
    for name in system:
        NAMING_MAP[name.lower()] = system[0]

SPORT_MAPPING = {
    "Band Sport": {
        "Beginner": {"start": 0, "height": 300},
        "Intermediate": {"start": 300, "height": 300},
        "Experienced": {"start": 600, "height": 300},
        "Expert": {"start": 900, "height": 300},
        "Elite": {"start": 1200, "height": 450},
    },
    "Ewbanks": {
        "1": {"start": 0, "height": 24},
        "2": {"start": 24, "height": 27},
        "3": {"start": 51, "height": 24},
        "4": {"start": 75, "height": 24},
        "5": {"start": 99, "height": 27},
        "6": {"start": 126, "height": 24},
        "7": {"start": 150, "height": 24},
        "8": {"start": 174, "height": 27},
        "9": {"start": 201, "height": 24},
        "10": {"start": 225, "height": 24},
        "11": {"start": 249, "height": 27},
        "12": {"start": 276, "height": 24},
        "13": {"start": 300, "height": 51},
        "14": {"start": 351, "height": 48},
        "15": {"start": 399, "height": 51},
        "16": {"start": 450, "height": 51},
        "17": {"start": 501, "height": 48},
        "18": {"start": 549, "height": 51},
        "19": {"start": 600, "height": 51},
        "20": {"start": 651, "height": 48},
        "21": {"start": 699, "height": 51},
        "22": {"start": 750, "height": 51},
        "23": {"start": 801, "height": 48},
        "24": {"start": 849, "height": 51},
        "25": {"start": 900, "height": 39},
        "26": {"start": 939, "height": 36},
        "27": {"start": 975, "height": 39},
        "28": {"start": 1014, "height": 36},
        "29": {"start": 1050, "height": 39},
        "30": {"start": 1089, "height": 36},
        "31": {"start": 1125, "height": 39},
        "32": {"start": 1164, "height": 36},
        "33": {"start": 1200, "height": 42},
        "34": {"start": 1242, "height": 45},
        "35": {"start": 1287, "height": 42},
        "36": {"start": 1329, "height": 42},
        "37": {"start": 1371, "height": 42},
        "38": {"start": 1413, "height": 45},
        "39": {"start": 1458, "height": 42},
    },
    "YDS": {
        "5.0": {"start": 66, "height": 39},
        "5.1": {"start": 105, "height": 39},
        "5.2": {"start": 144, "height": 39},
        "5.3": {"start": 183, "height": 39},
        "5.4": {"start": 222, "height": 39},
        "5.5": {"start": 261, "height": 39},
        "5.6": {"start": 300, "height": 60},
        "5.7": {"start": 360, "height": 60},
        "5.8": {"start": 420, "height": 60},
        "5.9": {"start": 480, "height": 60},
        "5.10a": {"start": 540, "height": 60},
        "5.10b": {"start": 600, "height": 39},
        "5.10c": {"start": 639, "height": 36},
        "5.10d": {"start": 675, "height": 39},
        "5.11a": {"start": 714, "height": 36},
        "5.11b": {"start": 750, "height": 39},
        "5.11c": {"start": 789, "height": 36},
        "5.11d": {"start": 825, "height": 39},
        "5.12a": {"start": 864, "height": 36},
        "5.12b": {"start": 900, "height": 39},
        "5.12c": {"start": 939, "height": 36},
        "5.12d": {"start": 975, "height": 39},
        "5.13a": {"start": 1014, "height": 36},
        "5.13b": {"start": 1050, "height": 39},
        "5.13c": {"start": 1089, "height": 36},
        "5.13d": {"start": 1125, "height": 39},
        "5.14a": {"start": 1164, "height": 36},
        "5.14b": {"start": 1200, "height": 42},
        "5.14c": {"start": 1242, "height": 45},
        "5.14d": {"start": 1287, "height": 42},
        "5.15a": {"start": 1329, "height": 42},
        "5.15b": {"start": 1371, "height": 42},
        "5.15c": {"start": 1413, "height": 45},
        "5.15d": {"start": 1458, "height": 42},
    },
    "NCCS Scale": {
        "F4": {"start": 0, "height": 150},
        "F5": {"start": 150, "height": 150},
        "F6": {"start": 300, "height": 75},
        "F7": {"start": 375, "height": 75},
        "F8": {"start": 450, "height": 75},
        "F9": {"start": 525, "height": 75},
        "F10": {"start": 600, "height": 60},
        "F11": {"start": 660, "height": 60},
        "F12": {"start": 720, "height": 60},
        "F13": {"start": 780, "height": 60},
        "F14": {"start": 840, "height": 60},
        "F15": {"start": 900, "height": 75},
        "F16": {"start": 975, "height": 75},
    },
    "French": {
        "1a": {"start": 0, "height": 18},
        "1a+": {"start": 18, "height": 15},
        "1b": {"start": 33, "height": 18},
        "1b+": {"start": 51, "height": 15},
        "1c": {"start": 66, "height": 18},
        "1c+": {"start": 84, "height": 15},
        "2a": {"start": 99, "height": 18},
        "2a+": {"start": 117, "height": 15},
        "2b": {"start": 132, "height": 18},
        "2b+": {"start": 150, "height": 18},
        "2c": {"start": 168, "height": 15},
        "2c+": {"start": 183, "height": 18},
        "3a": {"start": 201, "height": 15},
        "3a+": {"start": 216, "height": 18},
        "3b": {"start": 234, "height": 15},
        "3b+": {"start": 249, "height": 18},
        "3c": {"start": 267, "height": 15},
        "3c+": {"start": 282, "height": 18},
        "4a": {"start": 300, "height": 24},
        "4a+": {"start": 324, "height": 21},
        "4b": {"start": 345, "height": 24},
        "4b+": {"start": 369, "height": 24},
        "4c": {"start": 393, "height": 21},
        "4c+": {"start": 414, "height": 24},
        "5a": {"start": 438, "height": 24},
        "5a+": {"start": 462, "height": 24},
        "5b": {"start": 486, "height": 21},
        "5b+": {"start": 507, "height": 24},
        "5c": {"start": 531, "height": 24},
        "5c+": {"start": 555, "height": 21},
        "6a": {"start": 576, "height": 24},
        "6a+": {"start": 600, "height": 42},
        "6b": {"start": 642, "height": 45},
        "6b+": {"start": 687, "height": 42},
        "6c": {"start": 729, "height": 42},
        "6c+": {"start": 771, "height": 42},
        "7a": {"start": 813, "height": 45},
        "7a+": {"start": 858, "height": 42},
        "7b": {"start": 900, "height": 39},
        "7b+": {"start": 939, "height": 36},
        "7c": {"start": 975, "height": 39},
        "7c+": {"start": 1014, "height": 36},
        "8a": {"start": 1050, "height": 39},
        "8a+": {"start": 1089, "height": 36},
        "8b": {"start": 1125, "height": 39},
        "8b+": {"start": 1164, "height": 36},
        "8c": {"start": 1200, "height": 42},
        "8c+": {"start": 1242, "height": 45},
        "9a": {"start": 1287, "height": 42},
        "9a+": {"start": 1329, "height": 42},
        "9b": {"start": 1371, "height": 42},
        "9b+": {"start": 1413, "height": 45},
        "9c": {"start": 1458, "height": 42},
    },
    "British Tech.": {
        "1a": {"start": 0, "height": 30},
        "1b": {"start": 30, "height": 30},
        "1c": {"start": 60, "height": 30},
        "2a": {"start": 90, "height": 30},
        "2b": {"start": 120, "height": 30},
        "2c": {"start": 150, "height": 30},
        "3a": {"start": 180, "height": 30},
        "3b": {"start": 210, "height": 30},
        "3c": {"start": 240, "height": 30},
        "4a": {"start": 270, "height": 30},
        "4b": {"start": 300, "height": 99},
        "4c": {"start": 399, "height": 102},
        "5a": {"start": 501, "height": 99},
        "5b": {"start": 600, "height": 99},
        "5c": {"start": 699, "height": 102},
        "6a": {"start": 801, "height": 99},
        "6b": {"start": 900, "height": 99},
        "6c": {"start": 999, "height": 102},
        "7a": {"start": 1101, "height": 99},
        "7b": {"start": 1200, "height": 102},
        "7c": {"start": 1302, "height": 99},
    },
    "UIAA": {
        "1-": {"start": 0, "height": 27},
        "1": {"start": 27, "height": 27},
        "1+": {"start": 54, "height": 27},
        "2-": {"start": 81, "height": 27},
        "2": {"start": 108, "height": 27},
        "2+": {"start": 135, "height": 30},
        "3-": {"start": 165, "height": 27},
        "3": {"start": 192, "height": 27},
        "3+": {"start": 219, "height": 27},
        "4-": {"start": 246, "height": 27},
        "4": {"start": 273, "height": 27},
        "4+": {"start": 300, "height": 42},
        "5-": {"start": 342, "height": 45},
        "5": {"start": 387, "height": 42},
        "5+": {"start": 429, "height": 42},
        "6-": {"start": 471, "height": 42},
        "6": {"start": 513, "height": 45},
        "6+": {"start": 558, "height": 42},
        "7-": {"start": 600, "height": 54},
        "7": {"start": 654, "height": 54},
        "7+": {"start": 708, "height": 54},
        "8-": {"start": 762, "height": 54},
        "8": {"start": 816, "height": 54},
        "8+": {"start": 870, "height": 54},
        "9-": {"start": 924, "height": 45},
        "9": {"start": 969, "height": 48},
        "9+": {"start": 1017, "height": 45},
        "10-": {"start": 1062, "height": 45},
        "10": {"start": 1107, "height": 48},
        "10+": {"start": 1155, "height": 45},
        "11-": {"start": 1200, "height": 51},
        "11": {"start": 1251, "height": 48},
        "11+": {"start": 1299, "height": 51},
        "12-": {"start": 1350, "height": 51},
        "12": {"start": 1401, "height": 48},
        "12+": {"start": 1449, "height": 51},
    },
    "South African": {
        "1": {"start": 0, "height": 24},
        "2": {"start": 24, "height": 27},
        "3": {"start": 51, "height": 24},
        "4": {"start": 75, "height": 24},
        "5": {"start": 99, "height": 27},
        "6": {"start": 126, "height": 24},
        "7": {"start": 150, "height": 24},
        "8": {"start": 174, "height": 27},
        "9": {"start": 201, "height": 24},
        "10": {"start": 225, "height": 24},
        "11": {"start": 249, "height": 27},
        "12": {"start": 276, "height": 24},
        "13": {"start": 300, "height": 42},
        "14": {"start": 342, "height": 45},
        "15": {"start": 387, "height": 42},
        "16": {"start": 429, "height": 42},
        "17": {"start": 471, "height": 42},
        "18": {"start": 513, "height": 45},
        "19": {"start": 558, "height": 42},
        "20": {"start": 600, "height": 42},
        "21": {"start": 642, "height": 45},
        "22": {"start": 687, "height": 42},
        "23": {"start": 729, "height": 42},
        "24": {"start": 771, "height": 42},
        "25": {"start": 813, "height": 45},
        "26": {"start": 858, "height": 42},
        "27": {"start": 900, "height": 39},
        "28": {"start": 939, "height": 36},
        "29": {"start": 975, "height": 39},
        "30": {"start": 1014, "height": 36},
        "31": {"start": 1050, "height": 39},
        "32": {"start": 1089, "height": 36},
        "33": {"start": 1125, "height": 39},
        "34": {"start": 1164, "height": 36},
        "35": {"start": 1200, "height": 42},
        "36": {"start": 1242, "height": 45},
        "37": {"start": 1287, "height": 42},
        "38": {"start": 1329, "height": 42},
        "39": {"start": 1371, "height": 42},
        "40": {"start": 1413, "height": 45},
    },
    "Old South African": {
        "A1": {"start": 0, "height": 18},
        "A2": {"start": 18, "height": 21},
        "A3": {"start": 39, "height": 18},
        "B1": {"start": 57, "height": 18},
        "B2": {"start": 75, "height": 18},
        "B3": {"start": 93, "height": 21},
        "C1": {"start": 114, "height": 18},
        "C2": {"start": 132, "height": 18},
        "C3": {"start": 150, "height": 18},
        "D1": {"start": 168, "height": 21},
        "D2": {"start": 189, "height": 18},
        "D3": {"start": 207, "height": 18},
        "E1": {"start": 225, "height": 18},
        "E2": {"start": 243, "height": 21},
        "E3": {"start": 264, "height": 18},
        "F1": {"start": 282, "height": 18},
        "F2": {"start": 300, "height": 75},
        "F3": {"start": 375, "height": 75},
        "G1": {"start": 450, "height": 75},
        "G2": {"start": 525, "height": 75},
        "G3": {"start": 600, "height": 75},
        "H1": {"start": 675, "height": 75},
        "H2": {"start": 750, "height": 75},
        "H3": {"start": 825, "height": 75},
        "I1": {"start": 900, "height": 75},
        "I2": {"start": 975, "height": 75},
        "I3": {"start": 1050, "height": 75},
        "J1": {"start": 1125, "height": 75},
        "J2": {"start": 1200, "height": 45},
        "J3": {"start": 1245, "height": 42},
    },
    "Saxon": {
        "I": {"start": 0, "height": 99},
        "II": {"start": 99, "height": 102},
        "III": {"start": 201, "height": 99},
        "IV": {"start": 300, "height": 51},
        "V": {"start": 351, "height": 48},
        "VI": {"start": 399, "height": 51},
        "VIIa": {"start": 450, "height": 51},
        "VIIb": {"start": 501, "height": 48},
        "VIIc": {"start": 549, "height": 51},
        "VIIIa": {"start": 600, "height": 51},
        "VIIIb": {"start": 651, "height": 48},
        "VIIIc": {"start": 699, "height": 51},
        "IXa": {"start": 750, "height": 51},
        "IXb": {"start": 801, "height": 48},
        "IXc": {"start": 849, "height": 51},
        "Xa": {"start": 900, "height": 51},
        "Xb": {"start": 951, "height": 48},
        "Xc": {"start": 999, "height": 51},
        "XIa": {"start": 1050, "height": 51},
        "XIb": {"start": 1101, "height": 48},
        "XIc": {"start": 1149, "height": 51},
        "XIIa": {"start": 1200, "height": 51},
        "XIIb": {"start": 1251, "height": 48},
        "XIIc": {"start": 1299, "height": 51},
        "XIIIa": {"start": 1350, "height": 51},
        "XIIIb": {"start": 1401, "height": 48},
        "XIIIc": {"start": 1449, "height": 51},
    },
    "Finnish": {
        "1-": {"start": 0, "height": 27},
        "1": {"start": 27, "height": 27},
        "1+": {"start": 54, "height": 27},
        "2-": {"start": 81, "height": 27},
        "2": {"start": 108, "height": 27},
        "2+": {"start": 135, "height": 30},
        "3-": {"start": 165, "height": 27},
        "3": {"start": 192, "height": 27},
        "3+": {"start": 219, "height": 27},
        "4-": {"start": 246, "height": 27},
        "4": {"start": 273, "height": 27},
        "4+": {"start": 300, "height": 48},
        "5-": {"start": 348, "height": 51},
        "5": {"start": 399, "height": 48},
        "5+": {"start": 447, "height": 87},
        "6-": {"start": 534, "height": 84},
        "6": {"start": 618, "height": 60},
        "6+": {"start": 678, "height": 63},
        "7-": {"start": 741, "height": 60},
        "7": {"start": 801, "height": 63},
        "7+": {"start": 864, "height": 60},
        "8-": {"start": 924, "height": 30},
        "8": {"start": 954, "height": 30},
        "8+": {"start": 984, "height": 33},
        "9-": {"start": 1017, "height": 30},
        "9": {"start": 1047, "height": 30},
        "9+": {"start": 1077, "height": 30},
        "10-": {"start": 1107, "height": 33},
        "10": {"start": 1140, "height": 30},
        "10+": {"start": 1170, "height": 30},
        "11-": {"start": 1200, "height": 51},
        "11": {"start": 1251, "height": 48},
        "11+": {"start": 1299, "height": 51},
        "12-": {"start": 1350, "height": 51},
        "12": {"start": 1401, "height": 48},
        "12+": {"start": 1449, "height": 51},
    },
    "Norwegian": {
        "1-": {"start": 0, "height": 27},
        "1": {"start": 27, "height": 27},
        "1+": {"start": 54, "height": 27},
        "2-": {"start": 81, "height": 27},
        "2": {"start": 108, "height": 27},
        "2+": {"start": 135, "height": 30},
        "3-": {"start": 165, "height": 27},
        "3": {"start": 192, "height": 27},
        "3+": {"start": 219, "height": 27},
        "4-": {"start": 246, "height": 27},
        "4": {"start": 273, "height": 27},
        "4+": {"start": 300, "height": 48},
        "5-": {"start": 348, "height": 51},
        "5": {"start": 399, "height": 48},
        "5+": {"start": 447, "height": 87},
        "6-": {"start": 534, "height": 84},
        "6": {"start": 618, "height": 51},
        "6+": {"start": 669, "height": 51},
        "7-": {"start": 720, "height": 51},
        "7": {"start": 771, "height": 51},
        "7+": {"start": 822, "height": 51},
        "8-": {"start": 873, "height": 51},
        "8": {"start": 924, "height": 66},
        "8+": {"start": 990, "height": 63},
        "9-": {"start": 1053, "height": 66},
        "9": {"start": 1119, "height": 63},
        "9+": {"start": 1182, "height": 54},
        "10-": {"start": 1236, "height": 51},
        "10": {"start": 1287, "height": 54},
        "10+": {"start": 1341, "height": 54},
        "11-": {"start": 1395, "height": 51},
        "11": {"start": 1446, "height": 54},
        "11+": {"start": 1500, "height": 24},
        "12-": {"start": 1524, "height": 21},
        "12": {"start": 1545, "height": 24},
        "12+": {"start": 1569, "height": 21},
    },
    "Polish": {
        "I-": {"start": 0, "height": 27},
        "I": {"start": 27, "height": 27},
        "I+": {"start": 54, "height": 27},
        "II-": {"start": 81, "height": 27},
        "II": {"start": 108, "height": 27},
        "II+": {"start": 135, "height": 30},
        "III-": {"start": 165, "height": 27},
        "III": {"start": 192, "height": 27},
        "III+": {"start": 219, "height": 27},
        "IV-": {"start": 246, "height": 27},
        "IV": {"start": 273, "height": 27},
        "IV+": {"start": 300, "height": 51},
        "V-": {"start": 351, "height": 48},
        "V": {"start": 399, "height": 51},
        "V+": {"start": 450, "height": 51},
        "VI-": {"start": 501, "height": 48},
        "VI": {"start": 549, "height": 51},
        "VI+": {"start": 600, "height": 42},
        "VI.1": {"start": 642, "height": 45},
        "VI.1+": {"start": 687, "height": 42},
        "VI.2": {"start": 729, "height": 42},
        "VI.2+": {"start": 771, "height": 42},
        "VI.3": {"start": 813, "height": 45},
        "VI.3+": {"start": 858, "height": 42},
        "VI.4": {"start": 900, "height": 51},
        "VI.4+": {"start": 951, "height": 48},
        "VI.5": {"start": 999, "height": 51},
        "VI.5+": {"start": 1050, "height": 51},
        "VI.6": {"start": 1101, "height": 48},
        "VI.6+": {"start": 1149, "height": 51},
        "VI.7": {"start": 1200, "height": 51},
        "VI.7+": {"start": 1251, "height": 48},
        "VI.8": {"start": 1299, "height": 51},
        "VI.8+": {"start": 1350, "height": 51},
        "VI.9": {"start": 1401, "height": 48},
        "VI.9+": {"start": 1449, "height": 51},
    },
    "Brazil Technical": {
        "I": {"start": 0, "height": 60},
        "Isup": {"start": 60, "height": 60},
        "II": {"start": 120, "height": 60},
        "IIsup": {"start": 180, "height": 60},
        "III": {"start": 240, "height": 60},
        "IIIsup": {"start": 300, "height": 75},
        "IV": {"start": 375, "height": 75},
        "IVsup": {"start": 450, "height": 75},
        "V": {"start": 525, "height": 75},
        "Vsup": {"start": 600, "height": 42},
        "VI": {"start": 642, "height": 45},
        "VIsup": {"start": 687, "height": 42},
        "VIIa": {"start": 729, "height": 42},
        "VIIb": {"start": 771, "height": 45},
        "VIIc": {"start": 816, "height": 42},
        "VIIIa": {"start": 858, "height": 42},
        "VIIIb": {"start": 900, "height": 39},
        "VIIIc": {"start": 939, "height": 36},
        "IXa": {"start": 975, "height": 39},
        "IXb": {"start": 1014, "height": 36},
        "IXc": {"start": 1050, "height": 39},
        "Xa": {"start": 1089, "height": 36},
        "Xb": {"start": 1125, "height": 39},
        "Xc": {"start": 1164, "height": 36},
        "XIa": {"start": 1200, "height": 42},
        "XIb": {"start": 1242, "height": 45},
        "XIc": {"start": 1287, "height": 42},
        "XIIa": {"start": 1329, "height": 42},
        "XIIb": {"start": 1371, "height": 45},
        "XIIc": {"start": 1416, "height": 42},
    },
    "Swedish": {
        "1-": {"start": 0, "height": 30},
        "1": {"start": 30, "height": 30},
        "1+": {"start": 60, "height": 30},
        "2-": {"start": 90, "height": 30},
        "2": {"start": 120, "height": 30},
        "2+": {"start": 150, "height": 30},
        "3-": {"start": 180, "height": 30},
        "3": {"start": 210, "height": 30},
        "3+": {"start": 240, "height": 30},
        "4-": {"start": 270, "height": 30},
        "4": {"start": 300, "height": 54},
        "4+": {"start": 354, "height": 54},
        "5-": {"start": 408, "height": 51},
        "5": {"start": 459, "height": 54},
        "5+": {"start": 513, "height": 45},
        "6-": {"start": 558, "height": 42},
        "6": {"start": 600, "height": 54},
        "6+": {"start": 654, "height": 54},
        "7-": {"start": 708, "height": 54},
        "7": {"start": 762, "height": 54},
        "7+": {"start": 816, "height": 54},
        "8-": {"start": 870, "height": 57},
        "8": {"start": 927, "height": 57},
        "8+": {"start": 984, "height": 57},
        "9-": {"start": 1041, "height": 57},
        "9": {"start": 1098, "height": 57},
        "9+": {"start": 1155, "height": 57},
        "10-": {"start": 1212, "height": 57},
        "10": {"start": 1269, "height": 60},
        "10+": {"start": 1329, "height": 57},
        "11-": {"start": 1386, "height": 57},
        "11": {"start": 1443, "height": 57},
        "11+": {"start": 1500, "height": 24},
        "12-": {"start": 1524, "height": 21},
        "12": {"start": 1545, "height": 24},
        "12+": {"start": 1569, "height": 21},
    },
    "Russian": {
        "1A": {"start": 0, "height": 51},
        "1B": {"start": 51, "height": 48},
        "2A": {"start": 99, "height": 51},
        "2B": {"start": 150, "height": 51},
        "3A": {"start": 201, "height": 48},
        "3B": {"start": 249, "height": 51},
        "4A": {"start": 300, "height": 150},
        "4B": {"start": 450, "height": 150},
        "5A": {"start": 600, "height": 150},
        "5B": {"start": 750, "height": 150},
        "6A": {"start": 900, "height": 150},
        "6B": {"start": 1050, "height": 150},
        "7A": {"start": 1200, "height": 150},
        "7B": {"start": 1350, "height": 150},
    },
}


BOULDER_MAPPING = {
    "Band Boulder": {
        "Beginner": {"start": 0, "height": 200},
        "Intermediate": {"start": 200, "height": 200},
        "Experienced": {"start": 400, "height": 200},
        "Expert": {"start": 600, "height": 200},
        "Elite": {"start": 800, "height": 300},
    },
    "V-Scale": {
        "VB-": {"start": 0, "height": 66},
        "VB": {"start": 66, "height": 68},
        "VB+": {"start": 134, "height": 66},
        "V0-": {"start": 200, "height": 66},
        "V0": {"start": 266, "height": 68},
        "V0+": {"start": 334, "height": 66},
        "V1": {"start": 400, "height": 50},
        "V2": {"start": 450, "height": 50},
        "V3": {"start": 500, "height": 50},
        "V4": {"start": 550, "height": 50},
        "V5": {"start": 600, "height": 34},
        "V6": {"start": 634, "height": 32},
        "V7": {"start": 666, "height": 34},
        "V8": {"start": 700, "height": 34},
        "V9": {"start": 734, "height": 32},
        "V10": {"start": 766, "height": 34},
        "V11": {"start": 800, "height": 34},
        "V12": {"start": 834, "height": 32},
        "V13": {"start": 866, "height": 34},
        "V14": {"start": 900, "height": 34},
        "V15": {"start": 934, "height": 34},
        "V16": {"start": 968, "height": 32},
        "V17": {"start": 1000, "height": 34},
    },
    "B-Scale": {
        "B5.6": {"start": 200, "height": 40},
        "B5.7": {"start": 240, "height": 40},
        "B5.8": {"start": 280, "height": 40},
        "B5.9": {"start": 320, "height": 40},
        "B5.10": {"start": 360, "height": 88},
        "B5.10+": {"start": 448, "height": 28},
        "B1-": {"start": 476, "height": 42},
        "B1": {"start": 518, "height": 40},
        "B1+": {"start": 558, "height": 42},
        "B2-": {"start": 600, "height": 66},
        "B2": {"start": 666, "height": 68},
        "B2+": {"start": 734, "height": 66},
        "B3": {"start": 800, "height": 100},
    },
    "S-Scale": {
        "S1-": {"start": 400, "height": 26},
        "S1": {"start": 426, "height": 24},
        "S1+": {"start": 450, "height": 26},
        "S2-": {"start": 476, "height": 24},
        "S2": {"start": 500, "height": 26},
        "S2+": {"start": 526, "height": 24},
        "S3-": {"start": 550, "height": 26},
        "S3": {"start": 576, "height": 24},
        "S3+": {"start": 600, "height": 26},
        "S4-": {"start": 626, "height": 24},
        "S4": {"start": 650, "height": 26},
        "S4+": {"start": 676, "height": 24},
        "S5-": {"start": 700, "height": 26},
        "S5": {"start": 726, "height": 24},
        "S5+": {"start": 750, "height": 26},
        "S6-": {"start": 776, "height": 24},
        "S6": {"start": 800, "height": 34},
        "S6+": {"start": 834, "height": 32},
    },
    "P-Scale": {
        "P0": {"start": 200, "height": 50},
        "P1": {"start": 250, "height": 50},
        "P2": {"start": 300, "height": 50},
        "P3": {"start": 350, "height": 50},
        "P4": {"start": 400, "height": 50},
        "P5": {"start": 450, "height": 50},
        "P6": {"start": 500, "height": 50},
        "P7": {"start": 550, "height": 50},
        "P8": {"start": 600, "height": 50},
        "P9": {"start": 650, "height": 50},
        "P10": {"start": 700, "height": 50},
        "P11": {"start": 750, "height": 50},
        "P12": {"start": 800, "height": 34},
        "P13": {"start": 834, "height": 34},
        "P14": {"start": 868, "height": 32},
        "P15": {"start": 900, "height": 34},
        "P16": {"start": 934, "height": 34},
    },
    "Joshua Tree Scale": {
        "A-": {"start": 400, "height": 40},
        "A": {"start": 440, "height": 40},
        "A+": {"start": 480, "height": 40},
        "B-": {"start": 520, "height": 40},
        "B": {"start": 560, "height": 40},
        "B+": {"start": 600, "height": 40},
        "C-": {"start": 640, "height": 40},
        "C": {"start": 680, "height": 40},
        "C+": {"start": 720, "height": 40},
        "D-": {"start": 760, "height": 40},
        "D": {"start": 800, "height": 34},
        "D+": {"start": 834, "height": 32},
    },
    "Fontainebleau": {
        "1A": {"start": 0, "height": 12},
        "1A+": {"start": 12, "height": 10},
        "1B": {"start": 22, "height": 12},
        "1B+": {"start": 34, "height": 10},
        "1C": {"start": 44, "height": 12},
        "1C+": {"start": 56, "height": 10},
        "2A": {"start": 66, "height": 12},
        "2A+": {"start": 78, "height": 10},
        "2B": {"start": 88, "height": 12},
        "2B+": {"start": 100, "height": 12},
        "2C": {"start": 112, "height": 10},
        "2C+": {"start": 122, "height": 12},
        "3A": {"start": 134, "height": 10},
        "3A+": {"start": 144, "height": 12},
        "3B": {"start": 156, "height": 10},
        "3B+": {"start": 166, "height": 12},
        "3C": {"start": 178, "height": 10},
        "3C+": {"start": 188, "height": 12},
        "4A": {"start": 200, "height": 34},
        "4A+": {"start": 234, "height": 32},
        "4B": {"start": 266, "height": 34},
        "4B+": {"start": 300, "height": 34},
        "4C": {"start": 334, "height": 32},
        "4C+": {"start": 366, "height": 34},
        "5A": {"start": 400, "height": 20},
        "5A+": {"start": 420, "height": 20},
        "5B": {"start": 440, "height": 20},
        "5B+": {"start": 460, "height": 20},
        "5C": {"start": 480, "height": 20},
        "5C+": {"start": 500, "height": 20},
        "6A": {"start": 520, "height": 20},
        "6A+": {"start": 540, "height": 20},
        "6B": {"start": 560, "height": 20},
        "6B+": {"start": 580, "height": 20},
        "6C": {"start": 600, "height": 26},
        "6C+": {"start": 626, "height": 24},
        "7A": {"start": 650, "height": 26},
        "7A+": {"start": 676, "height": 24},
        "7B": {"start": 700, "height": 26},
        "7B+": {"start": 726, "height": 24},
        "7C": {"start": 750, "height": 26},
        "7C+": {"start": 776, "height": 24},
        "8A": {"start": 800, "height": 34},
        "8A+": {"start": 834, "height": 32},
        "8B": {"start": 866, "height": 34},
        "8B+": {"start": 900, "height": 34},
        "8C": {"start": 934, "height": 34},
        "8C+": {"start": 968, "height": 32},
        "9A": {"start": 1000, "height": 34},
        "9A+": {"start": 1034, "height": 14},
        "9B": {"start": 1048, "height": 12},
        "9B+": {"start": 1060, "height": 14},
        "9C": {"start": 1074, "height": 12},
        "9C+": {"start": 1086, "height": 14},
    },
    "Annot B-Scale": {
        "B1": {"start": 200, "height": 100},
        "B2": {"start": 300, "height": 100},
        "B3": {"start": 400, "height": 50},
        "B4": {"start": 450, "height": 50},
        "B5": {"start": 500, "height": 50},
        "B6": {"start": 550, "height": 50},
        "B7": {"start": 600, "height": 28},
        "B8": {"start": 628, "height": 30},
        "B9": {"start": 658, "height": 28},
        "B10": {"start": 686, "height": 28},
        "B11": {"start": 714, "height": 28},
        "B12": {"start": 742, "height": 30},
        "B13": {"start": 772, "height": 28},
        "B14": {"start": 800, "height": 56},
        "B15": {"start": 856, "height": 56},
        "B16": {"start": 912, "height": 56},
    },
    "Font Traverse": {
        "1A": {"start": 0, "height": 12},
        "1A+": {"start": 12, "height": 10},
        "1B": {"start": 22, "height": 12},
        "1B+": {"start": 34, "height": 10},
        "1C": {"start": 44, "height": 12},
        "1C+": {"start": 56, "height": 10},
        "2A": {"start": 66, "height": 12},
        "2A+": {"start": 78, "height": 10},
        "2B": {"start": 88, "height": 12},
        "2B+": {"start": 100, "height": 12},
        "2C": {"start": 112, "height": 10},
        "2C+": {"start": 122, "height": 12},
        "3A": {"start": 134, "height": 10},
        "3A+": {"start": 144, "height": 12},
        "3B": {"start": 156, "height": 10},
        "3B+": {"start": 166, "height": 12},
        "3C": {"start": 178, "height": 10},
        "3C+": {"start": 188, "height": 12},
        "4A": {"start": 200, "height": 16},
        "4A+": {"start": 216, "height": 14},
        "4B": {"start": 230, "height": 16},
        "4B+": {"start": 246, "height": 16},
        "4C": {"start": 262, "height": 14},
        "4C+": {"start": 276, "height": 16},
        "5A": {"start": 292, "height": 16},
        "5A+": {"start": 308, "height": 16},
        "5B": {"start": 324, "height": 14},
        "5B+": {"start": 338, "height": 16},
        "5C": {"start": 354, "height": 16},
        "5C+": {"start": 370, "height": 14},
        "6A": {"start": 384, "height": 16},
        "6A+": {"start": 400, "height": 28},
        "6B": {"start": 428, "height": 30},
        "6B+": {"start": 458, "height": 28},
        "6C": {"start": 486, "height": 28},
        "6C+": {"start": 514, "height": 28},
        "7A": {"start": 542, "height": 30},
        "7A+": {"start": 572, "height": 28},
        "7B": {"start": 600, "height": 26},
        "7B+": {"start": 626, "height": 24},
        "7C": {"start": 650, "height": 26},
        "7C+": {"start": 676, "height": 24},
        "8A": {"start": 700, "height": 26},
        "8A+": {"start": 726, "height": 24},
        "8B": {"start": 750, "height": 26},
        "8B+": {"start": 776, "height": 24},
        "8C": {"start": 800, "height": 28},
        "8C+": {"start": 828, "height": 30},
        "9A": {"start": 858, "height": 28},
        "9A+": {"start": 886, "height": 28},
        "9B": {"start": 914, "height": 28},
        "9B+": {"start": 942, "height": 30},
        "9C": {"start": 972, "height": 28},
    },
}

OTHER_MAPPING = {
    "Band Other": {
        "Beginner": {"start": 0, "height": 300},
        "Intermediate": {"start": 300, "height": 300},
        "Experienced": {"start": 600, "height": 300},
        "Expert": {"start": 900, "height": 300},
        "Elite": {"start": 1200, "height": 450},
    },
    "Aid": {
        "C0": {"start": 0, "height": 99},
        "C0+": {"start": 99, "height": 102},
        "C1": {"start": 201, "height": 99},
        "C1+": {"start": 300, "height": 99},
        "C2": {"start": 399, "height": 102},
        "C2+": {"start": 501, "height": 99},
        "C3": {"start": 600, "height": 150},
        "C3+": {"start": 750, "height": 150},
        "C4": {"start": 900, "height": 150},
        "C4+": {"start": 1050, "height": 150},
        "C5": {"start": 1200, "height": 99},
        "C5+": {"start": 1299, "height": 102},
        "C6": {"start": 1401, "height": 99},
    },
    "Alpine Ice": {
        "AI1-": {"start": 0, "height": 42},
        "AI1": {"start": 42, "height": 45},
        "AI1+": {"start": 87, "height": 42},
        "AI2-": {"start": 129, "height": 42},
        "AI2": {"start": 171, "height": 42},
        "AI2+": {"start": 213, "height": 45},
        "AI3-": {"start": 258, "height": 42},
        "AI3": {"start": 300, "height": 60},
        "AI3+": {"start": 360, "height": 60},
        "AI4-": {"start": 420, "height": 60},
        "AI4": {"start": 480, "height": 60},
        "AI4+": {"start": 540, "height": 60},
        "AI5-": {"start": 600, "height": 75},
        "AI5": {"start": 675, "height": 75},
        "AI5+": {"start": 750, "height": 75},
        "AI6-": {"start": 825, "height": 75},
        "AI6": {"start": 900, "height": 75},
        "AI6+": {"start": 975, "height": 75},
        "AI7-": {"start": 1050, "height": 75},
        "AI7": {"start": 1125, "height": 75},
        "AI7+": {"start": 1200, "height": 21},
        "AI8-": {"start": 1221, "height": 21},
        "AI8": {"start": 1242, "height": 18},
        "AI8+": {"start": 1260, "height": 21},
    },
    "Water Ice": {
        "WI1-": {"start": 0, "height": 42},
        "WI1": {"start": 42, "height": 45},
        "WI1+": {"start": 87, "height": 42},
        "WI2-": {"start": 129, "height": 42},
        "WI2": {"start": 171, "height": 42},
        "WI2+": {"start": 213, "height": 45},
        "WI3-": {"start": 258, "height": 42},
        "WI3": {"start": 300, "height": 60},
        "WI3+": {"start": 360, "height": 60},
        "WI4-": {"start": 420, "height": 60},
        "WI4": {"start": 480, "height": 60},
        "WI4+": {"start": 540, "height": 60},
        "WI5-": {"start": 600, "height": 75},
        "WI5": {"start": 675, "height": 75},
        "WI5+": {"start": 750, "height": 75},
        "WI6-": {"start": 825, "height": 75},
        "WI6": {"start": 900, "height": 75},
        "WI6+": {"start": 975, "height": 75},
        "WI7-": {"start": 1050, "height": 75},
        "WI7": {"start": 1125, "height": 75},
        "WI7+": {"start": 1200, "height": 21},
        "WI8-": {"start": 1221, "height": 21},
        "WI8": {"start": 1242, "height": 18},
        "WI8+": {"start": 1260, "height": 21},
        "WI9-": {"start": 1281, "height": 21},
        "WI9": {"start": 1302, "height": 21},
        "WI9+": {"start": 1323, "height": 21},
        "WI10-": {"start": 1344, "height": 21},
        "WI10": {"start": 1365, "height": 18},
        "WI10+": {"start": 1383, "height": 21},
        "WI11-": {"start": 1404, "height": 21},
        "WI11": {"start": 1425, "height": 21},
        "WI11+": {"start": 1446, "height": 21},
        "WI12-": {"start": 1467, "height": 18},
        "WI12": {"start": 1485, "height": 21},
        "WI12+": {"start": 1506, "height": 21},
        "WI13-": {"start": 1527, "height": 21},
        "WI13": {"start": 1548, "height": 21},
        "WI13+": {"start": 1569, "height": 21},
        "WI14-": {"start": 1590, "height": 18},
        "WI14": {"start": 1608, "height": 21},
        "WI14+": {"start": 1629, "height": 21},
    },
    "Mixed Rock/Ice": {
        "M1": {"start": 66, "height": 117},
        "M2": {"start": 183, "height": 117},
        "M3": {"start": 300, "height": 99},
        "M4": {"start": 399, "height": 102},
        "M5": {"start": 501, "height": 99},
        "M6": {"start": 600, "height": 150},
        "M7": {"start": 750, "height": 150},
        "M8": {"start": 900, "height": 150},
        "M9": {"start": 1050, "height": 150},
        "M10": {"start": 1200, "height": 99},
        "M11": {"start": 1299, "height": 102},
        "M12": {"start": 1401, "height": 99},
    },
    "Ferrata Schall": {
        "A": {"start": 0, "height": 99},
        "B": {"start": 99, "height": 102},
        "C": {"start": 201, "height": 99},
        "D": {"start": 300, "height": 300},
        "E": {"start": 600, "height": 300},
        "F": {"start": 900, "height": 300},
    },
    "Ferrata Num": {
        "1": {"start": 0, "height": 99},
        "2": {"start": 99, "height": 102},
        "3": {"start": 201, "height": 99},
        "4": {"start": 300, "height": 300},
        "5": {"start": 600, "height": 300},
        "6": {"start": 900, "height": 300},
    },
    "Ferrata French": {
        "F": {"start": 0, "height": 99},
        "PD": {"start": 99, "height": 102},
        "AD": {"start": 201, "height": 99},
        "D": {"start": 300, "height": 300},
        "TD": {"start": 600, "height": 300},
        "ED": {"start": 900, "height": 300},
    },
    "Scottish Winter Technical": {
        "1": {"start": 0, "height": 75},
        "2": {"start": 75, "height": 75},
        "3": {"start": 150, "height": 75},
        "4": {"start": 225, "height": 75},
        "5": {"start": 300, "height": 300},
        "6": {"start": 600, "height": 150},
        "7": {"start": 750, "height": 150},
        "8": {"start": 900, "height": 300},
        "9": {"start": 1200, "height": 99},
        "10": {"start": 1299, "height": 102},
        "11": {"start": 1401, "height": 99},
    },
}
